<?php

class Application_Model_Layout_UrlIntercept
{
    
   public function intercept()
   {
       
        $baseUrl = new Zend_View_Helper_BaseUrl();
        
        $ctrl  = Zend_Controller_Front::getInstance();
        $router=$ctrl->getRouter();

        $route['search']=new Zend_Controller_Router_Route('search',array('module'=>'default', 'controller'=>'list','action'=>'filter'));
        $router->addRoute('search',$route['search']);

        $route['page']=new Zend_Controller_Router_Route(':url',array('module'=>'default', 'controller'=>'page','action'=>'index'));
        $router->addRoute('page',$route['page']);
        
        $route['admission']=new Zend_Controller_Router_Route('admission',array('module'=>'default', 'controller'=>'admission','action'=>'index'));
        $router->addRoute('admission',$route['admission']);
        
        $route['contact']=new Zend_Controller_Router_Route('contact-us',array('module'=>'default', 'controller'=>'index','action'=>'contact'));
        $router->addRoute('contact',$route['contact']);

        $route['activities']=new Zend_Controller_Router_Route('activities',array('module'=>'default', 'controller'=>'activity','action'=>'index'));
        $router->addRoute('activities',$route['activities']);
        
        $route['activity']=new Zend_Controller_Router_Route('activity/:url',array('module'=>'default', 'controller'=>'activity','action'=>'activity'));
        $router->addRoute('activity',$route['activity']);
        
        $route['events']=new Zend_Controller_Router_Route('events',array('module'=>'default', 'controller'=>'event','action'=>'index'));
        $router->addRoute('events',$route['events']);
        
        $route['event']=new Zend_Controller_Router_Route('event/:url',array('module'=>'default', 'controller'=>'event','action'=>'view'));
        $router->addRoute('event',$route['event']);
        
        $route['eventUpcoming']=new Zend_Controller_Router_Route('event/upcoming',array('module'=>'default', 'controller'=>'event','action'=>'upcoming'));
        $router->addRoute('eventUpcoming',$route['eventUpcoming']);
        
        $route['eventJson']=new Zend_Controller_Router_Route('event/json',array('module'=>'default', 'controller'=>'event','action'=>'json'));
        $router->addRoute('eventJson',$route['eventJson']);
        
        $route['tc']=new Zend_Controller_Router_Route('tc',array('module'=>'default', 'controller'=>'tc','action'=>'index'));
        $router->addRoute('tc',$route['tc']);
        
        $route['alumni']=new Zend_Controller_Router_Route('alumni',array('module'=>'default', 'controller'=>'alumni','action'=>'index'));
        $router->addRoute('alumni',$route['alumni']);
        
        $route['news']=new Zend_Controller_Router_Route('news/:url',array('module'=>'default', 'controller'=>'news','action'=>'view'));
        $router->addRoute('news',$route['news']);
        
        $route['newsList']=new Zend_Controller_Router_Route('news',array('module'=>'default', 'controller'=>'news','action'=>'index'));
        $router->addRoute('newsList',$route['newsList']);
        
        $route['index']=new Zend_Controller_Router_Route('index',array('module'=>'default', 'controller'=>'index','action'=>'index'));
        $router->addRoute('index',$route['index']);
        
        $route['download']=new Zend_Controller_Router_Route('download/:folder/:filename',array('module'=>'default', 'controller'=>'Download','action'=>'index'));
        $router->addRoute('download',$route['download']);

        $route['download1']=new Zend_Controller_Router_Route('download/:folder/:sub_folder/:filename',array('module'=>'default', 'controller'=>'Download','action'=>'index'));
        $router->addRoute('download1',$route['download1']);

        $route['download2']=new Zend_Controller_Router_Route('download/:filename',array('module'=>'default', 'controller'=>'Download','action'=>'index'));
        $router->addRoute('download2',$route['download2']);
        
        $route['download3']=new Zend_Controller_Router_Route('download/:folder/:sub_folder/:sub_sub_folder/:filename',array('module'=>'default', 'controller'=>'Download','action'=>'index'));
        $router->addRoute('download3',$route['download3']);
        
        $route['img']=new Zend_Controller_Router_Route('img/:folder/:filename',array('module'=>'default', 'controller'=>'Img','action'=>'index'));
        $router->addRoute('img',$route['img']);

        $route['img1']=new Zend_Controller_Router_Route('img/:folder/:sub_folder/:filename',array('module'=>'default', 'controller'=>'Img','action'=>'index'));
        $router->addRoute('img1',$route['img1']);

        $route['img3']=new Zend_Controller_Router_Route('img/:folder/:sub_folder/:sub_sub_folder/:filename',array('module'=>'default', 'controller'=>'Img','action'=>'index'));
        $router->addRoute('img3',$route['img3']);

        $route['img2']=new Zend_Controller_Router_Route('img/:filename',array('module'=>'default', 'controller'=>'Img','action'=>'index'));
        $router->addRoute('img2',$route['img2']);
        
        $route['gallery']=new Zend_Controller_Router_Route('gallery',array('module'=>'default', 'controller'=>'gallery','action'=>'index'));
        $router->addRoute('gallery',$route['gallery']);

        $route['album']=new Zend_Controller_Router_Route('gallery/:title',array('module'=>'default', 'controller'=>'gallery','action'=>'items'));
        $router->addRoute('album',$route['album']);

        $route['dynasty']=new Zend_Controller_Router_Route('dynasty',array('module'=>'dynasty', 'controller'=>'index','action'=>'index'));
        $router->addRoute('dynasty',$route['dynasty']);
        
   }
   
}

